#
# ident "@(#)pdsm-d.x 1.55     01/10/04 SMI"
#
# Copyright (c) 2001 by Sun Microsystems, Inc
# All rights reserved.
#

[ use MANAGED-MODULE ]

[ load pdsm-m.x ]
[ requires template pdsm-models-d ]
[ requires template Config-ReaderStarcat-d ]
[ requires package pdsm ]
[ requires package unix ]
[ requires package configdsc ]

_procs   = { [ use PROC ] [ source pdsm-d.prc ] }
_filters = { [ source pdsm-d.flt ] }

[ use _procs ]

activateActions(post)            = startlog eventfwdreg
activateService(startlog)        = _procs
activateMethod(startlog)         = startlog
activateService(eventfwdreg)     = .iso*pdsm
activateMethod(eventfwdreg)      = eventFwdReg-prc

deactivateActions(pre)           = eventfwdunreg stoplog
deactivateService(eventfwdunreg) = .iso*pdsm
deactivateMethod(eventfwdunreg)  = eventFwdUnreg-prc
deactivateService(stoplog)       = _procs
deactivateMethod(stoplog)        = stoplog


platformView = { [ use templates.pdsm-models-d.platformView _procs ]
	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	platformInfo = {
		type            = active
		refreshService  = _internal
		refreshCommand  = getPlatformInfoCC
		refreshInterval = 180

		# read-write: 0 => power off, 1 => power on.
		systemControllerPower = { [ use _procs ]
			access                          = rw
			consoleHint:editAccess          = ro
			activateActions(post)           = setWriteGroups
			activateService(setWriteGroups) = _internal
			activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC] [getPlatOperGroupCC]"
			type                            = active
			refreshService                  = _internal
			refreshCommand                  = setValue 0 "ON"
			refreshInterval                 = 0
		}
	}

	# All Slot 0 boards in platform.
	platformSlot0BoardTable = { [ use templates.pdsm-models-d.platformBoardTable ]
		mediumDesc             = Platform Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:platformSlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getPlatformSlot0BoardsCC
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin platform_board
			index                          = boardID

			# Nomenclature id for board, e.g. "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# Plat Admn/Oper can power on/off even if board belongs to a domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-only (read-write in domain view by domain admin)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = {
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ]  %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:platformBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.platformView.platformSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}


		}
	}; # end of platformSlot0BoardTable

	# All Slot 1 boards in platform.
	platformSlot1BoardTable = { [ use templates.pdsm-models-d.platformBoardTable ]
		mediumDesc             = Platform Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:platformSlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getPlatformSlot1BoardsCC
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin platform_board
			index                          = boardID

			# Nomenclature id for board, e.g. "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# Plat Admn/Oper can power on/off even if board belongs to a domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-only (read-write in domain view by domain admin)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = {
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:platformBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.platformView.platformSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}
		}
	}; # end of platformSlot1BoardTable

	# All empty slots in platform.
	platformEmptySlotTable = { [ use templates.pdsm-models-d.platformBoardTable ]
		mediumDesc             = Platform Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:platformEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getPlatformEmptySlotsCC
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id for board, e.g. "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (read-write in domain view by domain admin)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = {
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:platformBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.platformView.platformEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of platformEmptySlotTable

	powerSupplyTable = { [ use templates.pdsm-models-d.powerSupplyTable ]
		type                   = active
		refreshService         = _internal
		refreshCommand         = getPowerSupplyStatesCC
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin power_supply
			index = powerSupplyID

			# Nomenclature id, e.g. "PS 1.1".
			powerSupplyID = {
			}

			# read-write: "OFF", "ON"
			# Power supply turned on manually so 1 is not a valid write value.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf powerSupplyID.${index} ] %value
			}
		}
	}; # end of powerSupplyTable

	fanTrayTable = { [ use templates.pdsm-models-d.fanTrayTable ]
		type                   = active
		refreshService         = _internal
		refreshCommand         = getFanTraySpeedsCC
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin fan_tray
			index = fanTrayID

			# Nomenclature id, e.g. "FT 1.1.1".
			fanTrayID = {
			}

			# read-write: 0 => power off, 1 => normal speed, 2 => high speed,
			# 3 => failed.  3 is not a valid write value.
			fanSpeed = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf fanTrayID.${index} ] %value
			}
		}
	}; # end of fanTrayTable

}; # end of platformView

#
#######################################################################################
# Begin section generated by createDomainViews
#######################################################################################
#

domainAView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain A View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainAView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC A] [getDmnRcfgGroupCC A] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain A Info
		consoleHint:mediumDesc = base.modules.pdsm:domainAView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC A
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC A
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain A Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainASlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC A
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A] [getDmnRcfgGroupCC A] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A] [getDmnRcfgGroupCC A] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A] [getDmnRcfgGroupCC A] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A] [getDmnRcfgGroupCC A] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A] [getDmnRcfgGroupCC A] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainAView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain A Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainASlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC A
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A] [getDmnRcfgGroupCC A] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A] [getDmnRcfgGroupCC A] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A] [getDmnRcfgGroupCC A] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A] [getDmnRcfgGroupCC A] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A] [getDmnRcfgGroupCC A] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainAView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain A Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainAEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC A
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A] [getDmnRcfgGroupCC A] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A] [getDmnRcfgGroupCC A] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A] [getDmnRcfgGroupCC A] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC A] [getDmnRcfgGroupCC A] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainAView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainAView


domainBView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain B View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainBView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC B] [getDmnRcfgGroupCC B] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain B Info
		consoleHint:mediumDesc = base.modules.pdsm:domainBView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC B
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC B
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain B Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainBSlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC B
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B] [getDmnRcfgGroupCC B] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B] [getDmnRcfgGroupCC B] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B] [getDmnRcfgGroupCC B] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B] [getDmnRcfgGroupCC B] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B] [getDmnRcfgGroupCC B] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainBView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain B Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainBSlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC B
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B] [getDmnRcfgGroupCC B] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B] [getDmnRcfgGroupCC B] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B] [getDmnRcfgGroupCC B] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B] [getDmnRcfgGroupCC B] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B] [getDmnRcfgGroupCC B] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainBView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain B Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainBEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC B
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B] [getDmnRcfgGroupCC B] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B] [getDmnRcfgGroupCC B] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B] [getDmnRcfgGroupCC B] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC B] [getDmnRcfgGroupCC B] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainBView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainBView


domainCView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain C View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainCView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC C] [getDmnRcfgGroupCC C] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain C Info
		consoleHint:mediumDesc = base.modules.pdsm:domainCView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC C
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC C
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain C Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainCSlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC C
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C] [getDmnRcfgGroupCC C] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C] [getDmnRcfgGroupCC C] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C] [getDmnRcfgGroupCC C] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C] [getDmnRcfgGroupCC C] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C] [getDmnRcfgGroupCC C] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainCView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain C Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainCSlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC C
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C] [getDmnRcfgGroupCC C] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C] [getDmnRcfgGroupCC C] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C] [getDmnRcfgGroupCC C] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C] [getDmnRcfgGroupCC C] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C] [getDmnRcfgGroupCC C] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainCView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain C Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainCEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC C
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C] [getDmnRcfgGroupCC C] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C] [getDmnRcfgGroupCC C] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C] [getDmnRcfgGroupCC C] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC C] [getDmnRcfgGroupCC C] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainCView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainCView


domainDView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain D View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainDView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC D] [getDmnRcfgGroupCC D] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain D Info
		consoleHint:mediumDesc = base.modules.pdsm:domainDView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC D
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC D
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain D Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainDSlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC D
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D] [getDmnRcfgGroupCC D] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D] [getDmnRcfgGroupCC D] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D] [getDmnRcfgGroupCC D] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D] [getDmnRcfgGroupCC D] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D] [getDmnRcfgGroupCC D] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainDView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain D Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainDSlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC D
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D] [getDmnRcfgGroupCC D] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D] [getDmnRcfgGroupCC D] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D] [getDmnRcfgGroupCC D] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D] [getDmnRcfgGroupCC D] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D] [getDmnRcfgGroupCC D] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainDView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain D Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainDEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC D
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D] [getDmnRcfgGroupCC D] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D] [getDmnRcfgGroupCC D] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D] [getDmnRcfgGroupCC D] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC D] [getDmnRcfgGroupCC D] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainDView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainDView


domainEView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain E View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainEView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC E] [getDmnRcfgGroupCC E] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain E Info
		consoleHint:mediumDesc = base.modules.pdsm:domainEView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC E
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC E
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain E Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainESlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC E
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E] [getDmnRcfgGroupCC E] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E] [getDmnRcfgGroupCC E] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E] [getDmnRcfgGroupCC E] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E] [getDmnRcfgGroupCC E] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E] [getDmnRcfgGroupCC E] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainEView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain E Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainESlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC E
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E] [getDmnRcfgGroupCC E] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E] [getDmnRcfgGroupCC E] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E] [getDmnRcfgGroupCC E] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E] [getDmnRcfgGroupCC E] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E] [getDmnRcfgGroupCC E] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainEView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain E Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainEEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC E
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E] [getDmnRcfgGroupCC E] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E] [getDmnRcfgGroupCC E] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E] [getDmnRcfgGroupCC E] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC E] [getDmnRcfgGroupCC E] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainEView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainEView


domainFView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain F View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainFView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC F] [getDmnRcfgGroupCC F] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain F Info
		consoleHint:mediumDesc = base.modules.pdsm:domainFView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC F
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC F
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain F Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainFSlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC F
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F] [getDmnRcfgGroupCC F] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F] [getDmnRcfgGroupCC F] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F] [getDmnRcfgGroupCC F] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F] [getDmnRcfgGroupCC F] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F] [getDmnRcfgGroupCC F] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainFView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain F Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainFSlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC F
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F] [getDmnRcfgGroupCC F] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F] [getDmnRcfgGroupCC F] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F] [getDmnRcfgGroupCC F] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F] [getDmnRcfgGroupCC F] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F] [getDmnRcfgGroupCC F] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainFView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain F Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainFEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC F
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F] [getDmnRcfgGroupCC F] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F] [getDmnRcfgGroupCC F] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F] [getDmnRcfgGroupCC F] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC F] [getDmnRcfgGroupCC F] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainFView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainFView


domainGView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain G View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainGView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC G] [getDmnRcfgGroupCC G] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain G Info
		consoleHint:mediumDesc = base.modules.pdsm:domainGView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC G
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC G
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain G Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainGSlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC G
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G] [getDmnRcfgGroupCC G] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G] [getDmnRcfgGroupCC G] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G] [getDmnRcfgGroupCC G] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G] [getDmnRcfgGroupCC G] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G] [getDmnRcfgGroupCC G] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainGView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain G Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainGSlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC G
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G] [getDmnRcfgGroupCC G] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G] [getDmnRcfgGroupCC G] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G] [getDmnRcfgGroupCC G] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G] [getDmnRcfgGroupCC G] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G] [getDmnRcfgGroupCC G] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainGView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain G Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainGEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC G
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G] [getDmnRcfgGroupCC G] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G] [getDmnRcfgGroupCC G] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G] [getDmnRcfgGroupCC G] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC G] [getDmnRcfgGroupCC G] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainGView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainGView


domainHView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain H View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainHView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC H] [getDmnRcfgGroupCC H] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain H Info
		consoleHint:mediumDesc = base.modules.pdsm:domainHView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC H
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC H
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain H Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainHSlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC H
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H] [getDmnRcfgGroupCC H] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H] [getDmnRcfgGroupCC H] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H] [getDmnRcfgGroupCC H] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H] [getDmnRcfgGroupCC H] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H] [getDmnRcfgGroupCC H] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainHView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain H Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainHSlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC H
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H] [getDmnRcfgGroupCC H] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H] [getDmnRcfgGroupCC H] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H] [getDmnRcfgGroupCC H] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H] [getDmnRcfgGroupCC H] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H] [getDmnRcfgGroupCC H] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainHView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain H Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainHEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC H
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H] [getDmnRcfgGroupCC H] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H] [getDmnRcfgGroupCC H] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H] [getDmnRcfgGroupCC H] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC H] [getDmnRcfgGroupCC H] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainHView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainHView


domainIView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain I View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainIView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC I] [getDmnRcfgGroupCC I] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain I Info
		consoleHint:mediumDesc = base.modules.pdsm:domainIView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC I
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC I
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain I Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainISlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC I
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I] [getDmnRcfgGroupCC I] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I] [getDmnRcfgGroupCC I] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I] [getDmnRcfgGroupCC I] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I] [getDmnRcfgGroupCC I] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I] [getDmnRcfgGroupCC I] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainIView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain I Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainISlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC I
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I] [getDmnRcfgGroupCC I] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I] [getDmnRcfgGroupCC I] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I] [getDmnRcfgGroupCC I] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I] [getDmnRcfgGroupCC I] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I] [getDmnRcfgGroupCC I] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainIView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain I Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainIEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC I
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I] [getDmnRcfgGroupCC I] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I] [getDmnRcfgGroupCC I] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I] [getDmnRcfgGroupCC I] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC I] [getDmnRcfgGroupCC I] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainIView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainIView


domainJView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain J View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainJView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC J] [getDmnRcfgGroupCC J] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain J Info
		consoleHint:mediumDesc = base.modules.pdsm:domainJView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC J
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC J
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain J Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainJSlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC J
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J] [getDmnRcfgGroupCC J] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J] [getDmnRcfgGroupCC J] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J] [getDmnRcfgGroupCC J] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J] [getDmnRcfgGroupCC J] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J] [getDmnRcfgGroupCC J] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainJView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain J Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainJSlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC J
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J] [getDmnRcfgGroupCC J] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J] [getDmnRcfgGroupCC J] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J] [getDmnRcfgGroupCC J] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J] [getDmnRcfgGroupCC J] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J] [getDmnRcfgGroupCC J] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainJView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain J Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainJEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC J
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J] [getDmnRcfgGroupCC J] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J] [getDmnRcfgGroupCC J] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J] [getDmnRcfgGroupCC J] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC J] [getDmnRcfgGroupCC J] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainJView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainJView


domainKView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain K View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainKView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC K] [getDmnRcfgGroupCC K] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain K Info
		consoleHint:mediumDesc = base.modules.pdsm:domainKView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC K
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC K
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain K Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainKSlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC K
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K] [getDmnRcfgGroupCC K] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K] [getDmnRcfgGroupCC K] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K] [getDmnRcfgGroupCC K] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K] [getDmnRcfgGroupCC K] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K] [getDmnRcfgGroupCC K] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainKView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain K Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainKSlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC K
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K] [getDmnRcfgGroupCC K] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K] [getDmnRcfgGroupCC K] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K] [getDmnRcfgGroupCC K] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K] [getDmnRcfgGroupCC K] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K] [getDmnRcfgGroupCC K] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainKView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain K Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainKEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC K
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K] [getDmnRcfgGroupCC K] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K] [getDmnRcfgGroupCC K] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K] [getDmnRcfgGroupCC K] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC K] [getDmnRcfgGroupCC K] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainKView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainKView


domainLView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain L View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainLView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC L] [getDmnRcfgGroupCC L] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain L Info
		consoleHint:mediumDesc = base.modules.pdsm:domainLView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC L
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC L
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain L Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainLSlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC L
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L] [getDmnRcfgGroupCC L] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L] [getDmnRcfgGroupCC L] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L] [getDmnRcfgGroupCC L] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L] [getDmnRcfgGroupCC L] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L] [getDmnRcfgGroupCC L] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainLView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain L Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainLSlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC L
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L] [getDmnRcfgGroupCC L] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L] [getDmnRcfgGroupCC L] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L] [getDmnRcfgGroupCC L] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L] [getDmnRcfgGroupCC L] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L] [getDmnRcfgGroupCC L] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainLView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain L Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainLEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC L
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L] [getDmnRcfgGroupCC L] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L] [getDmnRcfgGroupCC L] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L] [getDmnRcfgGroupCC L] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC L] [getDmnRcfgGroupCC L] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainLView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainLView


domainMView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain M View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainMView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC M] [getDmnRcfgGroupCC M] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain M Info
		consoleHint:mediumDesc = base.modules.pdsm:domainMView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC M
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC M
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain M Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainMSlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC M
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M] [getDmnRcfgGroupCC M] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M] [getDmnRcfgGroupCC M] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M] [getDmnRcfgGroupCC M] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M] [getDmnRcfgGroupCC M] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M] [getDmnRcfgGroupCC M] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainMView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain M Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainMSlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC M
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M] [getDmnRcfgGroupCC M] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M] [getDmnRcfgGroupCC M] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M] [getDmnRcfgGroupCC M] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M] [getDmnRcfgGroupCC M] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M] [getDmnRcfgGroupCC M] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainMView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain M Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainMEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC M
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M] [getDmnRcfgGroupCC M] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M] [getDmnRcfgGroupCC M] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M] [getDmnRcfgGroupCC M] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC M] [getDmnRcfgGroupCC M] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainMView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainMView


domainNView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain N View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainNView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC N] [getDmnRcfgGroupCC N] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain N Info
		consoleHint:mediumDesc = base.modules.pdsm:domainNView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC N
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC N
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain N Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainNSlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC N
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N] [getDmnRcfgGroupCC N] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N] [getDmnRcfgGroupCC N] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N] [getDmnRcfgGroupCC N] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N] [getDmnRcfgGroupCC N] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N] [getDmnRcfgGroupCC N] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainNView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain N Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainNSlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC N
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N] [getDmnRcfgGroupCC N] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N] [getDmnRcfgGroupCC N] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N] [getDmnRcfgGroupCC N] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N] [getDmnRcfgGroupCC N] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N] [getDmnRcfgGroupCC N] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainNView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain N Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainNEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC N
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N] [getDmnRcfgGroupCC N] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N] [getDmnRcfgGroupCC N] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N] [getDmnRcfgGroupCC N] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC N] [getDmnRcfgGroupCC N] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainNView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainNView


domainOView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain O View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainOView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC O] [getDmnRcfgGroupCC O] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain O Info
		consoleHint:mediumDesc = base.modules.pdsm:domainOView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC O
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC O
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain O Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainOSlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC O
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O] [getDmnRcfgGroupCC O] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O] [getDmnRcfgGroupCC O] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O] [getDmnRcfgGroupCC O] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O] [getDmnRcfgGroupCC O] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O] [getDmnRcfgGroupCC O] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainOView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain O Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainOSlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC O
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O] [getDmnRcfgGroupCC O] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O] [getDmnRcfgGroupCC O] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O] [getDmnRcfgGroupCC O] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O] [getDmnRcfgGroupCC O] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O] [getDmnRcfgGroupCC O] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainOView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain O Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainOEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC O
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O] [getDmnRcfgGroupCC O] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O] [getDmnRcfgGroupCC O] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O] [getDmnRcfgGroupCC O] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC O] [getDmnRcfgGroupCC O] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainOView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainOView


domainPView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain P View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainPView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC P] [getDmnRcfgGroupCC P] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain P Info
		consoleHint:mediumDesc = base.modules.pdsm:domainPView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC P
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC P
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain P Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainPSlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC P
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P] [getDmnRcfgGroupCC P] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P] [getDmnRcfgGroupCC P] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P] [getDmnRcfgGroupCC P] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P] [getDmnRcfgGroupCC P] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P] [getDmnRcfgGroupCC P] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainPView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain P Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainPSlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC P
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P] [getDmnRcfgGroupCC P] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P] [getDmnRcfgGroupCC P] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P] [getDmnRcfgGroupCC P] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P] [getDmnRcfgGroupCC P] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P] [getDmnRcfgGroupCC P] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainPView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain P Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainPEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC P
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P] [getDmnRcfgGroupCC P] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P] [getDmnRcfgGroupCC P] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P] [getDmnRcfgGroupCC P] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC P] [getDmnRcfgGroupCC P] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainPView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainPView


domainQView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain Q View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainQView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC Q] [getDmnRcfgGroupCC Q] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain Q Info
		consoleHint:mediumDesc = base.modules.pdsm:domainQView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC Q
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC Q
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain Q Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainQSlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC Q
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q] [getDmnRcfgGroupCC Q] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q] [getDmnRcfgGroupCC Q] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q] [getDmnRcfgGroupCC Q] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q] [getDmnRcfgGroupCC Q] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q] [getDmnRcfgGroupCC Q] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainQView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain Q Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainQSlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC Q
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q] [getDmnRcfgGroupCC Q] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q] [getDmnRcfgGroupCC Q] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q] [getDmnRcfgGroupCC Q] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q] [getDmnRcfgGroupCC Q] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q] [getDmnRcfgGroupCC Q] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainQView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain Q Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainQEmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC Q
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q] [getDmnRcfgGroupCC Q] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q] [getDmnRcfgGroupCC Q] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q] [getDmnRcfgGroupCC Q] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC Q] [getDmnRcfgGroupCC Q] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainQView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainQView


domainRView = { [ use templates.pdsm-models-d.domainView _procs ]
	mediumDesc                             = Domain R View
	consoleHint:mediumDesc                 = base.modules.pdsm:domainRView

	userAccess(%adminUsers,read)           = none
	groupAccess(%adminGroups,read)         = none
	userAccess(%adminCommunities,read)     = none
	userAccess(%operatorUsers,read)        = none
	groupAccess(%operatorGroups,read)      = none
	userAccess(%operatorCommunities,read)  = none
	userAccess(%generalUsers,read)         = none
	groupAccess(%generalGroups,read)       = none
	userAccess(%generalCommunities,read)   = none
	userAccess(%adminUsers,write)          = none
	groupAccess(%adminGroups,write)        = none
	userAccess(%adminCommunities,write)    = none
	userAccess(%operatorUsers,write)       = none
	groupAccess(%operatorGroups,write)     = none
	userAccess(%operatorCommunities,write) = none
	userAccess(%generalUsers,write)        = none
	groupAccess(%generalGroups,write)      = none
	userAccess(%generalCommunities,write)  = none

	activateActions(post)                  = setReadGroups
	activateService(setReadGroups)         = _internal
	activateCommand(setReadGroups)         = setReadGroupAccess-prc "[getDmnAdmnGroupCC R] [getDmnRcfgGroupCC R] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"

	domainInfo = { [ use _filters ]
		mediumDesc             = Domain R Info
		consoleHint:mediumDesc = base.modules.pdsm:domainRView.domainInfo
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainInfoCC R
		refreshFilter          = getDomainInfoFlt
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_info
			index                          = domainID

			# A-R for Starcat.
			domainID = {
			}

			# read-write: writing string value => addtag command, null => deletetag
			# tagcommand.  String value must be legal addtag value, else SET fails.
			domainTag = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				setActions                      = *tagop
				setService(tagop)               = _internal
				#setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID ] %value
				setCommand(tagop)               = tagop-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Powered off, POST, OBP, kadb, SOLARIS.
			domainState = {
			}

			# Only meaningful if state is SOLARIS.
			solarisNodeName = {
			}

			# read-write.  keyswitchPosition
			# e.g. "on", "standby", "off", "diag", "secure".
			keyswitch = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R]"
				setActions                      = *setkeyswitch
				setService(setkeyswitch)        = _internal
				#setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID ] %value
				setCommand(setkeyswitch)        = setkeyswitch-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# read-write:
			# List of sys board ids for domain ACL, e.g. "CPU 2.0, IO 5.0".
			domainACL = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = getDomainACLBoardsCC R
				refreshInterval                 = 180
				setActions                      = *setupplatform
				setService(setupplatform)       = _internal
				#setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID ] %value
				setCommand(setupplatform)       = setupplatform-prc %securityName %[ valueOf domainID.${index} ] %value
			}

			# Nomenclature id for IO board that conatins the SRAM used for domain
			# <-> SC communication.  Only meaningful if state is SOLARIS.
			primaryIOBoard = {
			}

			# Nomenclature id for IO board that holds the physical network
			# connection to the internal ethernet.
			internalEthernetBoard = {
			}

			# write-only: write non-zero integer to reset domain
			reset = { [ use _procs ]
				access                          = wo
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R]"
				setActions                      = *reset
				setService(reset)               = _internal
				#setCommand(reset)               = reset-prc %securityName %[ valueOf domainID ] %value
				setCommand(reset)               = reset-prc %securityName %[ valueOf domainID.${index} ] %value
			}
		}
	}; # domainInfo

	domainSlot0BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain R Slot 0 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainRSlot0BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot0BoardsCC R
#		refreshFilter          = debugRefreshCommand
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R] [getDmnRcfgGroupCC R] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R] [getDmnRcfgGroupCC R] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R] [getDmnRcfgGroupCC R] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R] [getDmnRcfgGroupCC R] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R] [getDmnRcfgGroupCC R] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}


			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainRView.domainSlot0BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot0BoardTable

	domainSlot1BoardTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain R Slot 1 Boards
		consoleHint:mediumDesc = base.modules.pdsm:domainRSlot1BoardTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainSlot1BoardsCC R
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin domain_board
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-write: "OFF", "ON"
			# DmnX Admn/Rcfg can power on/off if board belongs to the domain.
			powerState = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R] [getDmnRcfgGroupCC R] [getPlatAdmnGroupCC] [getPlatOperGroupCC]"
				setActions                      = powerop
				setService(powerop)             = _internal
				setCommand(powerop)             = powerop-prc %securityName %[ valueOf boardID.${index} ] %value
			}

			# read-write: 
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R]"
				setActions                      = testboard
				setService(testboard)           = _internal
				setCommand(testboard)           = testboard-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R] [getDmnRcfgGroupCC R] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R] [getDmnRcfgGroupCC R] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R] [getDmnRcfgGroupCC R] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R] [getDmnRcfgGroupCC R] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainRView.domainSlot1BoardTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}



		}
	}; # end of domainSlot1BoardTable

	domainEmptySlotTable = { [ use templates.pdsm-models-d.domainBoardTable ]
		mediumDesc             = Domain R Empty Slots
		consoleHint:mediumDesc = base.modules.pdsm:domainREmptySlotTable
		type                   = active
		refreshService         = _internal
		refreshCommand         = getDomainEmptySlotsCC R
		refreshInterval        = 180

		tableEntry = {
			consoleHint:tableMenuGenerator = com.sun.symon.apps.admin.platformAdmin.CaXCAdmin empty_slot
			index                          = boardID

			# Nomenclature id, e.g., "IO 3.0".
			boardID = {
			}

			# Available, assigned, active.
			boardState = {
			}

			# read-only (can't power on/off an empty slot)
			powerState = {
			}

			# read-only (can't test an empty slot)
			# Unknown, POST, PASSED, FAILED, DEGRADED, CONNECT_RDY
			testStatus = { [ use _procs ]
			}

			# POST level used for testing 0-127, valid when state is PASSED.
			testLevel = {
			}

			# A-R for Starcat.
			domainID = {
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# PlatAdmn can assign board to domain,
			# Dmn Admn/Rcfg can assign, connect, configure.
			addboardCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R] [getDmnRcfgGroupCC R] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *addboardPreVal
				validateService(addboardPreVal) = _internal
				validateCommand(addboardPreVal) = addboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = addboard
				setService(addboard)            = _internal
				setCommand(addboard)            = addboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  configurationState
			# e.g. "unassign", "unconfigure", "disconnect".
			# PlatAdmn can unassign board from domain if in assign state,
			# Dmn Admn/Rcfg can unassign, disconnect, unconfigure.
			deleteboardCmd = { [ use _procs ]
				access                             = rw
				consoleHint:editAccess             = ro
				activateActions(post)              = setWriteGroups
				activateService(setWriteGroups)    = _internal
				activateCommand(setWriteGroups)    = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R] [getDmnRcfgGroupCC R] [getPlatAdmnGroupCC]"
				type                               = active
				refreshService                     = _internal
				refreshCommand                     = tableRefresh "--"
				refreshInterval                    = 0
				validateActions(pre)               = *deleteboardPreVal
				validateService(deleteboardPreVal) = _internal
				validateCommand(deleteboardPreVal) = deleteboardPreVal-prc %securityName %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                         = deleteboard
				setService(deleteboard)            = _internal
				setCommand(deleteboard)            = deleteboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			# write-only.  "targetDomainID configurationState"
			# e.g. "A assign", "B configure", "C connect", etc.
			# User must have privileges in both domains.
			moveboardCmd = { [ use _procs ]
				access                           = rw
				consoleHint:editAccess           = ro
				activateActions(post)            = setWriteGroups
				activateService(setWriteGroups)  = _internal
				activateCommand(setWriteGroups)  = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R] [getDmnRcfgGroupCC R] [getPlatAdmnGroupCC]"
				type                             = active
				refreshService                   = _internal
				refreshCommand                   = tableRefresh "--"
				refreshInterval                  = 0
				validateActions(pre)             = *moveboardPreVal
				validateService(moveboardPreVal) = _internal
				validateCommand(moveboardPreVal) = moveboardPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ valueOf domainID.${index} ] %[ valueOf boardState.${index} ] %[ list ${index} ] %value
				setActions                       = moveboard
				setService(moveboard)            = _internal
				setCommand(moveboard)            = moveboard-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			abortCmd = { [ use _procs ]
				access                          = rw
				consoleHint:editAccess          = ro
				activateActions(post)           = setWriteGroups
				activateService(setWriteGroups) = _internal
				activateCommand(setWriteGroups) = setWriteGroupAccess-prc "[getDmnAdmnGroupCC R] [getDmnRcfgGroupCC R] [getPlatAdmnGroupCC]"
				type                            = active
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "--"
				refreshInterval                 = 0
				validateActions(pre)            = *abortPreVal
				validateService(abortPreVal)    = _internal
				validateCommand(abortPreVal)    = abortCmdPreVal-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
				setActions                      = abortCmd
				setService(abortCmd)            = _internal
				setCommand(abortCmd)            = abortCmd-prc %securityName %[ valueOf boardID.${index} ] %[ list ${index} ] %value
			}

			cmdStatus = { [ use _procs ]
				mediumDesc             		= Command Status
				consoleHint:mediumDesc		= base.modules.pdsm:domainBoardTable.cmdStatus
				type                            = derived
				refreshTrigger                  = .iso*pdsm.domainRView.domainEmptySlotTable
				refreshService                  = _internal
				refreshCommand                  = tableRefresh "0"
				refreshInterval                 = 0
			}

		}
	}; # end of domainEmptySlotTable
}; # end of domainRView

#
#######################################################################################
# End section generated by createDomainViews
#######################################################################################
#


# This is a required file, so do not comment out this line!
[ load pdsm-d.def ]

# Used for failover to move the module to a(n) down/ok state
# while the SC transitions to a(n) standby/active state.
availability = { [ use templates.Config-ReaderStarcat-d.availability ]
   type            = active
   refreshMode     = sync
   timeoutInterval = 120
   initInterval    = 0
   initHoldoff     = 2
   refreshInterval = 60
   refreshService  = _internal
   refreshCommand  = moduleAvailability

   alarmChecks             = "disabled-eq error-ne";
   alarmlimit:disabled-eq  = "UNAVAILABLE";
   alarmlimit:error-ne     = "AVAILABLE";

   disabledMessage = "- Module is on the Spare SC or required SMS daemon(s) is stopped"
   errorMessage    = "Fatal Error"

   statusActions(ok)               = forceok
   statusActions(error-ne)         = forcedown
   statusActions(disabled-eq)      = forcedown

   statusService(forcedown)        = _superior
   statusCommand(forcedown)        = forceModuleState down %[ toe_self ]

   statusService(forceok)          = _superior
   statusCommand(forceok)          = forceModuleState ok %[ toe_self ]
}
